Subject: bug#21803: Bug #21803 Hunting: status?

From: zimoun <[email-masked]>
Date: Wed, 13 Nov 2019 19:14:04 +0100

On Wed, 13 Nov 2019 at 14:42, Ludovic Courtès <[email-masked]> wrote:

> zimoun <[email-masked]> skribis:
>
> > From my test with Guix d258d9c7d222e6b64531c14293f41bd8d62ea4f7,
> > "guix challenge guitarix" and "guix build --rounds=3" do not report
> > issues about reproducibility.
> >
> > And from my knowledge, the waf-based packages are not affected.
> >
> > Do you agree to close this bug since it is not relevant anymore?
>
> If you’ve checked that a local build gives the same result several times
> in a row (make sure it actually rebuilt things; “guix build --rounds=3
> foo” does nothing if “foo” is already in the store), then you can
> definitely close it!

I think I did but how do you do that cleanly?

I am testing with "brute force" method: "guix gc -C" then proceed. I
notice unexpected behaviour; not sure it is the right place to report.

1. The first issue is that the two following commands do not populate
the same way.

(Because my machine is not very powerful, before building I populate
the store with the dependencies from substitutes.)

--8<---------------cut here---------------start------------->8---
$ guix environment guitarix -- echo Done
--8<---------------cut here---------------start------------->8---

--8<---------------cut here---------------start------------->8---
$ guix build `guix show guitarix | recsel -R dependencies`
--8<---------------cut here---------------start------------->8---

The main issue is about `gettext-minimal`.

(Below, I pinpoint with star (*) which is not common between the both
commands and with sharp (#) which appears twice in the same list.)

2. The second issue is the inconsistent outputs:

--8<---------------cut here---------------start------------->8---
$ guix build guitarix --no-substitutes --dry-run
The following derivations would be built:
   /gnu/store/ikdd9740fifdcqwmf170gmlrlkirwa8j-guitarix-0.38.1.drv
   /gnu/store/ismr6xqwsi165phwjx9kbcrmr9lsz61r-module-import.drv
   /gnu/store/zsigy6yfllikzxmnlii6ivxczlv8k5h3-guitarix2-0.38.1.tar.xz.drv
   /gnu/store/zya9lhiqqr24lbgkp510v1z9s4qdcqid-module-import-compiled.drv
--8<---------------cut here---------------start------------->8---

--8<---------------cut here---------------start------------->8---
$ guix build guitarix --no-substitutes
building /gnu/store/4fqc5dydkc4svkl1zjyz5ymnyycfakx8-module-import.drv...
successfully built /gnu/store/4fqc5dydkc4svkl1zjyz5ymnyycfakx8-module-import.drv
building /gnu/store/s659hxn6zh7havik6bghip7mslarxfcx-ghostscript-9.27.tar.xz.drv...

Starting download of
/gnu/store/gz3sh75g8rwvqqhmj7z1wbdrn36bwk1g-ghostscript-9.27.tar.xz
>From https://github.com/ArtifexSoftware/ghostpdl-downloads/releases/download/gs927/ghostscript-9.27.tar.xz...
following redirection to
`https://github-production-release-asset-2e65be.s3.amazonaws.com/50461376/70f10a80-56c2-11e9-8208-d05d335afc94?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=AKIAIWNJYAX4CSVEH53A%2F20191113%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20191113T173022Z&X-Amz-Expires=300&X-Amz-Signature=6498073580142d43071eba62060a7379b0dae94f148fc191b1a8ec53f284107a&X-Amz-SignedHeaders=host&actor_id=0&response-content-disposition=attachment%3B%20filename%3Dghostscript-9.27.tar.xz&response-content-type=application%2Foctet-stream'...
downloading from
https://github.com/ArtifexSoftware/ghostpdl-downloads/releases/download/gs927/ghostscript-9.27.tar.xz...
 ghostscript-9.27.tar.xz  31.6MiB

4.9MiB/s 00:02 [######            ]  34.0%
^C
--8<---------------cut here---------------start------------->8---

Why `ghostscript` is downloaded and not reported; neither by the two
populating commands?
Do I miss the obvious?

So I add it to the store with "guix build ghostscript" then I run
again "guix build guitarix --no-substitutes" and again pieces are
missing:

--8<---------------cut here---------------start------------->8---
[...]
 downloading from
http://downloads.sourceforge.net/project/cunit/CUnit/2.1-3/CUnit-2.1-3.tar.bz2
[...]
 downloading from https://c-ares.haxx.se/download/c-ares-1.15.0.tar.gz
[...]
 downloading from http://www.digip.org/jansson/releases/jansson-2.12.tar.bz2
--8<---------------cut here---------------start------------->8---

Then other pieces are missing. I suppose it is related to BAG and
depth of the dependencies.

Therefore, how is it possible to check the reproducibility of a
package without compiling the World? For example, the test suite of
Git kills my desktop machine. :-)

Thank you in advance.
simon

--

--8<---------------cut here---------------start------------->8---
$ guix environment guitarix --dry-run -- echo Done
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
The following derivations would be built:
   /gnu/store/9p90w999xdqyhv6k1x5wp0sq312l10ri-profile.drv
   /gnu/store/qxhk96270rgn61nv7znbmgj5d4pamzgw-config.scm.drv
116.4 MB would be downloaded:
*   /gnu/store/zjnz5gg04zfyzn5gi66lay8sgv6i4rj8-module-import-compiled
*   /gnu/store/05kyg8pg8zzbrn366imllhxavdcwqgsk-mkfontdir-1.0.7
*   /gnu/store/0dsc5kh6qfwshfaq01iqrfpdhlaici8n-libfontenc-1.1.4
*   /gnu/store/r1p07fn372rcxzvfzqwm44w16n8gcqfc-mkfontscale-1.2.1
*   /gnu/store/sclspjcznk50s894irfk2wzn6nfnxa2g-guile-gdbm-ffi-20120209.fa1d5b6
*   /gnu/store/s2hqjjp057l2k6ix3yaa7cc2dpwxpfm7-module-import
*   /gnu/store/pfqvay49nk9cja05sqw5cwm7fn3w4fn3-module-import-compiled
*   /gnu/store/zqyr73kc60f2dyj2ykl3ijk86kias0yc-module-import-compiled
*   /gnu/store/nsrym6zn3yb4390fazx1gq8rg0m8dhkd-llvm-8.0.0
*   /gnu/store/vf5lkc27z5rcbvaw6rkdmqisyg923m5r-mesa-19.1.4
*   /gnu/store/kjlnb30snlawpb4fb8qwhbzhcpbxlckk-libepoxy-1.5.3
*   /gnu/store/4ppvmpyir7qwmhzkfxnqlb27j85rjqyz-gtk+-3.24.10-bin
*   /gnu/store/wwwnp8025yb7k6qbv28hi1l6qy6j7d9z-module-import-compiled
*   /gnu/store/iaqmwj2290z5nnrk69bss6r0d9lpr8cs-python2-2.7.16
   /gnu/store/fzjnhsfgkqcsqjzan2dxkqgw6fl5kniy-lv2-1.16.0
   /gnu/store/p8yabbkcywr8a5pcy3dg6w0mjaw6ddlq-zita-resampler-1.3.0
*   /gnu/store/7zlxdamykwrd1vjp3kxv54qyyv7ya6jr-util-macros-1.19.2
   /gnu/store/ksjvb9m0ky0g7yv27v70l44h8nj6v1qy-gtkmm-2.24.5
   /gnu/store/pxwz526473fynfhwnljs0wb5vd2qcg4c-atkmm-2.28.0
   /gnu/store/l8nphg0idd8pfddyad8f92lx8d1hc053-python-wrapper-3.7.4
   /gnu/store/ms1q76ikx7f78y7i8crg42lyv88xfvfv-ghostscript-with-cups-9.27
   /gnu/store/xc98lvvcbaabn0v1md34hxbdn5ivg72g-cups-filters-1.25.1
   /gnu/store/lv9xckn9in3cbswaprv5j9xgsa8wghpr-cups-2.2.11
   /gnu/store/vb4g1m42k156gwiwq62hd1db92ndvnch-gtk+-2.24.32
*   /gnu/store/b824dq3bccq0bhjli3li0fzi11lg1bh3-xorgproto-2019.1
*   /gnu/store/arzn28zwj8bqv2qiid7ybx3aad49c3pd-libpthread-stubs-0.4
   /gnu/store/j1ldfckx81mm6fydlhzw03cv7hsr58ya-faust-0.9.90
   /gnu/store/h10dlkcf019047d8jmjkw2w0h96zad2d-gperf-3.1
   /gnu/store/zc4shgdr8pw9z5rcv9657p37wyha4nqa-fftwf-3.3.8
   /gnu/store/dgkwjigfbadm0jn2y9z6d29lq0i3wj97-zita-convolver-3.1.0
   /gnu/store/rm9q1vqhg333nwpywsbf017fj88dlgsf-eigen-3.3.5
   /gnu/store/3vgaq9ga221mjx21sll3lxqxdgclgws4-flac-1.3.3
   /gnu/store/y8wkxd3pmp29k1j0knmg9hnjnrfnm9iy-libsndfile-1.0.28
   /gnu/store/f5g4av3mwn7zr81yqr1gn9hpb5d2c4m4-boost-1.70.0
   /gnu/store/wrlkvgl0lz7b03gwqf27ql6pjkmj5v6r-bdb-6.2.32
   /gnu/store/q1mz5mid5y4y3z12g5ify10ci7h72dnq-jack-0.125.0
*   /gnu/store/5686hrxkbsm6ycf1ks9nja3mjjxjpl9a-desktop-file-utils-0.23
   /gnu/store/a9rsi05xscg0bq6q0rbhcv5586zvf3li-cairomm-1.12.2
   /gnu/store/s0djjrx5x8c12sa1p0wl10crvl7rzs0v-libsigc++-2.10.2
   /gnu/store/78w7y0lxar70j512iqw8x3nimzj10yga-python-3.7.4
*   /gnu/store/fpj5mspa7jmksixqpnzbvzs3q2vbqq31-glib-2.60.6-bin
   /gnu/store/b8pr2k0i2zd07zmb7kpffmcimqi337if-glib-2.60.6
   /gnu/store/94s92fpkk14y514qwf4f4hnc54qz0zfj-glibmm-2.60.0
   /gnu/store/dhnzrhs9vf40p5v09817rbcd3ks07slc-pangomm-2.42.0
*   /gnu/store/20ilkjz5kd98zdm6rsk6zdw5p9nh0hq7-perl-xml-parser-2.44
   /gnu/store/qw4p5qwd1f1kcwspm455njd4ny7v9gww-sratom-0.6.2
   /gnu/store/r0jrq3jvvxrbx7sbqhs168yxaan9311v-sord-0.16.2
   /gnu/store/77h391w9aynwwb5j83yakav5m6qi7bbg-lilv-0.24.4
   /gnu/store/vfcbn39fwng8d35gvic51f235fxvj7y1-intltool-0.51.0
*   /gnu/store/k3m2kz55qiklkyihnnvhxhv0ylsyyaqc-module-import-compiled
   /gnu/store/6zasp7vh5jww0naybhva026z1967scr7-ladspa-1.13
   /gnu/store/v557q2wd91sm5vj3lrwjzajafblklr6w-libxslt-1.1.33
   /gnu/store/k2m4q2av9hw73hw2jx6qrxqdyh855398-openssl-1.1.1c
   /gnu/store/f8aljw2qhv3d1br9czn8v5afbgfdrxkg-cyrus-sasl-2.1.27
   /gnu/store/bjxd9jzc560d6i3i35f5yy5mljk0ib6m-openldap-2.4.47
   /gnu/store/4m8dlhrzis07787xznx73ang35c3lly1-curl-7.65.3
   /gnu/store/dgv36cg3x3pi2v00arwlfcvq3p7id4h5-raptor2-2.0.15
   /gnu/store/x5k749kbwbmbd1sn0j6ybpcc9450fba2-lrdf-0.6.1
   /gnu/store/pvz6zmy4lwaicjk07999gbsaim0p4iai-serd-0.30.0
The following profile hooks would be built:
   /gnu/store/5jc3lsfm9mj8smp3a4g4aqkq05zrjsq5-xdg-desktop-database.drv
   /gnu/store/6csqwjlmnsmpcgcdrxjm841d54xf7pcl-xdg-mime-database.drv
   /gnu/store/6k5057zfsxqf3kn5iqf27zz91jl7zbmh-info-dir.drv
   /gnu/store/chzwnq3kl6gc36sh2krlbfvxfga13cq5-gtk-icon-themes.drv
   /gnu/store/i22j0197hy2byv23f884dd0j6y7r93hp-manual-database.drv
   /gnu/store/immlg222fg9wpnjb04j6czwp8gviw7as-gtk-im-modules.drv
   /gnu/store/j7m81fkl3qacc1cnzifqiy0a4hzb8i6s-fonts-dir.drv
   /gnu/store/j96f9a5m2d7wi8pdvj6d5jvldbzjc3k8-glib-schemas.drv
   /gnu/store/mf3abgwykhp243r8cbfjwl1w7x6d7dkm-ca-certificate-bundle.drv
--8<---------------cut here---------------end--------------->8---

--8<---------------cut here---------------start------------->8---
$ guix build `guix show guitarix | recsel -R dependencies` --dry-run
substitute: updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
76.1 MB would be downloaded:
   /gnu/store/f5g4av3mwn7zr81yqr1gn9hpb5d2c4m4-boost-1.70.0
*   /gnu/store/33f8qhxa69dmd43yqdx3wq1b2hqjddgb-curl-7.65.3-doc
#   /gnu/store/4m8dlhrzis07787xznx73ang35c3lly1-curl-7.65.3
   /gnu/store/rm9q1vqhg333nwpywsbf017fj88dlgsf-eigen-3.3.5
   /gnu/store/j1ldfckx81mm6fydlhzw03cv7hsr58ya-faust-0.9.90
*   /gnu/store/3pfj84hcpw0xfxh8briill4c5mnk51ha-gettext-minimal-0.20.1-doc
*   /gnu/store/ypwxvcnrsdn0snllv944ckylwx3p1m79-gettext-minimal-0.20.1
   /gnu/store/h10dlkcf019047d8jmjkw2w0h96zad2d-gperf-3.1
*   /gnu/store/vmwm54y790r3ipbyd1l8qzxhzw0byv7d-gtk+-2.24.32-doc
#   /gnu/store/vb4g1m42k156gwiwq62hd1db92ndvnch-gtk+-2.24.32
   /gnu/store/pxwz526473fynfhwnljs0wb5vd2qcg4c-atkmm-2.28.0
   /gnu/store/ms1q76ikx7f78y7i8crg42lyv88xfvfv-ghostscript-with-cups-9.27
   /gnu/store/xc98lvvcbaabn0v1md34hxbdn5ivg72g-cups-filters-1.25.1
   /gnu/store/lv9xckn9in3cbswaprv5j9xgsa8wghpr-cups-2.2.11
#   /gnu/store/vb4g1m42k156gwiwq62hd1db92ndvnch-gtk+-2.24.32
   /gnu/store/a9rsi05xscg0bq6q0rbhcv5586zvf3li-cairomm-1.12.2
   /gnu/store/s0djjrx5x8c12sa1p0wl10crvl7rzs0v-libsigc++-2.10.2
   /gnu/store/fpj5mspa7jmksixqpnzbvzs3q2vbqq31-glib-2.60.6-bin
   /gnu/store/b8pr2k0i2zd07zmb7kpffmcimqi337if-glib-2.60.6
   /gnu/store/94s92fpkk14y514qwf4f4hnc54qz0zfj-glibmm-2.60.0
   /gnu/store/dhnzrhs9vf40p5v09817rbcd3ks07slc-pangomm-2.42.0
   /gnu/store/ksjvb9m0ky0g7yv27v70l44h8nj6v1qy-gtkmm-2.24.5
   /gnu/store/vfcbn39fwng8d35gvic51f235fxvj7y1-intltool-0.51.0
   /gnu/store/wrlkvgl0lz7b03gwqf27ql6pjkmj5v6r-bdb-6.2.32
   /gnu/store/q1mz5mid5y4y3z12g5ify10ci7h72dnq-jack-0.125.0
   /gnu/store/6zasp7vh5jww0naybhva026z1967scr7-ladspa-1.13
   /gnu/store/3vgaq9ga221mjx21sll3lxqxdgclgws4-flac-1.3.3
   /gnu/store/y8wkxd3pmp29k1j0knmg9hnjnrfnm9iy-libsndfile-1.0.28
   /gnu/store/qw4p5qwd1f1kcwspm455njd4ny7v9gww-sratom-0.6.2
   /gnu/store/r0jrq3jvvxrbx7sbqhs168yxaan9311v-sord-0.16.2
   /gnu/store/pvz6zmy4lwaicjk07999gbsaim0p4iai-serd-0.30.0
   /gnu/store/77h391w9aynwwb5j83yakav5m6qi7bbg-lilv-0.24.4
   /gnu/store/v557q2wd91sm5vj3lrwjzajafblklr6w-libxslt-1.1.33
   /gnu/store/f8aljw2qhv3d1br9czn8v5afbgfdrxkg-cyrus-sasl-2.1.27
   /gnu/store/bjxd9jzc560d6i3i35f5yy5mljk0ib6m-openldap-2.4.47
#   /gnu/store/4m8dlhrzis07787xznx73ang35c3lly1-curl-7.65.3
   /gnu/store/dgv36cg3x3pi2v00arwlfcvq3p7id4h5-raptor2-2.0.15
   /gnu/store/x5k749kbwbmbd1sn0j6ybpcc9450fba2-lrdf-0.6.1
   /gnu/store/k2m4q2av9hw73hw2jx6qrxqdyh855398-openssl-1.1.1c
   /gnu/store/78w7y0lxar70j512iqw8x3nimzj10yga-python-3.7.4
   /gnu/store/l8nphg0idd8pfddyad8f92lx8d1hc053-python-wrapper-3.7.4
   /gnu/store/fzjnhsfgkqcsqjzan2dxkqgw6fl5kniy-lv2-1.16.0
   /gnu/store/zc4shgdr8pw9z5rcv9657p37wyha4nqa-fftwf-3.3.8
   /gnu/store/dgkwjigfbadm0jn2y9z6d29lq0i3wj97-zita-convolver-3.1.0
   /gnu/store/p8yabbkcywr8a5pcy3dg6w0mjaw6ddlq-zita-resampler-1.3.0
--8<---------------cut here---------------end--------------->8---